#include "Automobile.h"
std::istream& operator >>(std::istream& p_in, Automobile& p_auto)
{
    std::cout << "OWNER'S SURNAME: ";
    p_in >> p_auto.m_surnameOwner;
    std::cout << "CAR MODEL CODE: ";
    p_in >> p_auto.m_codeModel;
    std::cout << "CAR MODEL: ";
    p_in >> p_auto.m_modelAuto;
    std::cout << "FUEL GRADE: ";
    p_in >> p_auto.m_gradeFuel;
    std::cout << "ENGINE POWER: ";
    p_in >> p_auto.m_powerEngine;
    std::cout << "VOLUME OF THE TANK: ";
    p_in >> p_auto.m_volumeTank;
    std::cout << "REMAINING FUEL: ";
    p_in >> p_auto.m_remainderFuel;
    std::cout << "OIL VOLUME: ";
    p_in >> p_auto.m_volumeOil;
    return p_in;
};

std::ostream& operator << (std::ostream& p_out, const Automobile& p_auto)
{
    p_out << "OWNER'S SURNAME: " << p_auto.m_surnameOwner << std::endl
        << "ID: " << p_auto.m_id << std::endl
        << "CAR MODEL CODE: " << p_auto.m_codeModel << std::endl
        << "CAR MODEL: " << p_auto.m_modelAuto << std::endl
        << "FUEL GRADE: " << p_auto.m_gradeFuel << std::endl
        << "ENGINE POWER: " << p_auto.m_powerEngine << std::endl
        << "VOLUME OF THE TANK: " << p_auto.m_volumeTank << std::endl
        << "REMAINING FUEL: " << p_auto.m_remainderFuel << std::endl
        << "OIL VOLUME: " << p_auto.m_volumeOil << std::endl;
    return p_out;
};

void fileToContainer(const std::string& p_filename, std::map<size_t, Automobile>& p_auto) {
    std::ifstream binaryFile(p_filename, std::ios::binary);
    if (!binaryFile.is_open()) {
        std::cout << "Can't open the file!" << std::endl;
        return;
    };
    while (binaryFile) {
        Automobile car;
        binaryFile.read(reinterpret_cast<char*>(&car.m_id), sizeof(car.m_id));
        if (!binaryFile) break;
        readStringFromFile(binaryFile, car.m_surnameOwner);
        binaryFile.read(reinterpret_cast<char*>(&car.m_codeModel), sizeof(car.m_codeModel));
        readStringFromFile(binaryFile, car.m_modelAuto);
        readStringFromFile(binaryFile, car.m_gradeFuel);
        binaryFile.read(reinterpret_cast<char*>(&car.m_powerEngine), sizeof(car.m_powerEngine));
        binaryFile.read(reinterpret_cast<char*>(&car.m_volumeTank), sizeof(car.m_volumeTank));
        binaryFile.read(reinterpret_cast<char*>(&car.m_remainderFuel), sizeof(car.m_remainderFuel));
        binaryFile.read(reinterpret_cast<char*>(&car.m_volumeOil), sizeof(car.m_volumeOil));
        p_auto[car.m_id] = car;
    }
    binaryFile.close();
}

void containerToFile(const std::string& p_filename, std::map<size_t, Automobile>& p_auto)
{
    std::ofstream binaryFile(p_filename, std::ios::binary);
    std::ofstream tempFile("temp.dat", std::ios::binary);
    if (!binaryFile.is_open())
    {
        std::cout << "Can't open the file!" << std::endl;
        return;
    };
    for (const auto& pair : p_auto) {
        const Automobile& car = pair.second;
        binaryFile.write(reinterpret_cast<const char*>(&car.m_id), sizeof(car.m_id));
        writeStringToFile(binaryFile, car.m_surnameOwner);
        binaryFile.write(reinterpret_cast<const char*>(&car.m_codeModel), sizeof(car.m_codeModel));
        writeStringToFile(binaryFile, car.m_modelAuto);
        writeStringToFile(binaryFile, car.m_gradeFuel);
        binaryFile.write(reinterpret_cast<const char*>(&car.m_powerEngine), sizeof(car.m_powerEngine));
        binaryFile.write(reinterpret_cast<const char*>(&car.m_volumeTank), sizeof(car.m_volumeTank));
        binaryFile.write(reinterpret_cast<const char*>(&car.m_remainderFuel), sizeof(car.m_remainderFuel));
        binaryFile.write(reinterpret_cast<const char*>(&car.m_volumeOil), sizeof(car.m_volumeOil));
    }
    auto name = p_filename.c_str();
    std::remove(name);
    std::rename("temp.dat", name);
};

void addAutomobile(std::map<size_t, Automobile>& p_auto, const Automobile& p_new_auto, const std::string& p_filename)
{
    p_auto[p_new_auto.m_id] = p_new_auto;
    containerToFile(p_filename, p_auto);
};

void removeAutomobile(std::map<size_t, Automobile>& p_auto, size_t p_id, const std::string& p_filename)
{
    p_auto.erase(p_id);
    containerToFile(p_filename, p_auto);;
};

void replaceAutomobile(std::map<size_t, Automobile>& p_auto, size_t p_id, const Automobile& p_new_auto, const std::string& p_filename) {
    p_auto.erase(p_id);
    p_auto[p_id] = p_new_auto;
    containerToFile(p_filename, p_auto);
};

void searchByAutomobileModel(std::map<size_t, Automobile>& p_auto, const std::string& p_output_filename, const std::string& p_model)
{
    std::ofstream outputFile(p_output_filename);
    if (!outputFile.is_open())
    {
        std::cout << "Can't open the file!" << std::endl;
        return;
    }
    for (auto& car : p_auto)
        if (car.second.m_modelAuto == p_model)
            outputFile << car.second << std::endl;
};

void searchByFuelGrade(std::map<size_t, Automobile>& p_auto, const std::string& p_output_filename, const std::string& p_fuel)
{
    std::ofstream outputFile(p_output_filename);
    if (!outputFile.is_open())
    {
        std::cout << "Can't open the file!" << std::endl;
        return;
    }
    for (auto& car : p_auto)
        if (car.second.m_gradeFuel == p_fuel)
            outputFile << car.second << std::endl;
};

void searchByEnginePower(std::map<size_t, Automobile>& p_auto, const std::string& p_output_filename, size_t p_engine)
{
    std::ofstream outputFile(p_output_filename);
    if (!outputFile.is_open())
    {
        std::cout << "Can't open the file!" << std::endl;
        return;
    }
    for (auto& car : p_auto)
        if (car.second.m_powerEngine == p_engine)
            outputFile << car.second << std::endl;
};

void convertBinaryToTextFile(std::map<size_t, Automobile>& p_auto, const std::string& p_output_filename)
{
    std::ofstream outputFile(p_output_filename);
    if (!outputFile.is_open())
    {
        std::cout << "Can't open the file!" << std::endl;
        return;
    }
    for (auto& car : p_auto)
        outputFile << car.second << std::endl;
}

void writeStringToFile(std::ofstream& out, const std::string& str) {
    size_t length = str.length();
    out.write(reinterpret_cast<const char*>(&length), sizeof(length));
    out.write(str.c_str(), length);
}

void readStringFromFile(std::ifstream& in, std::string& str) {
    size_t length;
    in.read(reinterpret_cast<char*>(&length), sizeof(length));
    str.resize(length);
    in.read(&str[0], length);
}